/* TODO - Nothing! Do not modify this file */


#include <stdio.h> 
#include <stdlib.h> 

#include "setup.h"

/* Students will provide function to work on 2D matrices */
/* in file tools.c*/
extern int isMatrixSorted( int data[NB_ROWS][NB_COLS] ); 
extern void matrixSort(int data[NB_ROWS][NB_COLS]);

/* Students will provide tests to ensure both functions are working*/
/* These are all defined in a 3 dimensional array in file tests.c */
extern int tests_inputs[NB_TESTS][NB_ROWS][NB_COLS]; 
extern int tests_expected[NB_TESTS];

/* Forward definition of prototype, defined at the end of this source file*/
void runAllTests(); 




/* MAIN starts here */
int main()
{
    printf("\tWelcome to PA201\n\n");
    runAllTests();    
    
    return EXIT_SUCCESS;    
}




void extractTest ( int destination[NB_ROWS][NB_COLS], int test){ 
     /* ROLE 
              Copies the data relevant to the specified test from the mytests
              three dimensional array to the destination matrix.
        PARAMETERS 
        destination 2D matrix in which we will copy the data corresponding 
                    to a given test. The tests are copied from the 
                    mytests global variable made available from tests.c 
        test        the number of the test we want to extract from mytests 
                    and copy into destination. The number ranges from 0 to 
                    NB_TESTS as defined in setup.h
     */              
     int i, j; /* loop indexes */
     
     for(i=0; i < NB_ROWS ; i++){
              for(j=0; j < NB_COLS; j++){
                       destination[i][j] = tests_inputs[test][i][j];
              }        
     }  
}


void displayTest( int data[NB_ROWS][NB_COLS] ){
     /* ROLE 
                   Displays the contents of the matrix on STDOUT
        PARAMETERS 
                   data   the matrix to be displayed.
     */
    int i,j; /* loop indexes*/
    
    for(i=0; i < NB_ROWS ; i++){
             printf("\t\t");
             for(j=0; j < NB_COLS; j++){
                       printf("%2d ", data[i][j]);  
             }
             printf("\n"); 
    } 
}

void runTests1(){ 
     /* ROLE      
                  runs all the tests specified in tests_inputs in tests.c and used
                  to validate the isMatrixSorted function
     */ 
     int t;        
     /* loop index; the number of the test we're working on*/
     
     int oneTest[NB_ROWS][NB_COLS]; 
     /* the matrix in which we store the test we're working on*/
     
     int returnValue; 
     /* the value returned by isMatrixSorted on the test we're working on */
     
     
     printf("\nValidating isMatrixSorted function...\n\n"); 
     for(t = 0 ; t < NB_TESTS; t++){
              
              /* let's extract the test and run our function on it */
              extractTest( oneTest, t);       
              returnValue = isMatrixSorted(oneTest); 
              
              /* We display the test matrix only if in verbose mode */
              #ifdef VERBOSE_TESTINGS
              printf("Running test #%d\t", t); 
              printf("%s \t", returnValue?"sorted":"not sorted"); 
              printf("\n"); 
              displayTest(oneTest);
              
              #else
              /* Otherwize, we just make sure the result is what we expected*/
              if (returnValue != tests_expected[t])
                              printf("Test #%d \tFAILED\n", t);
              #endif
        }
}

void runTests2(){ 
     /* ROLE      
                  runs all the tests specified in tests_inputs in tests.c and used
                  to validate the sortMatrix function
        WARNING   these tests are relying on isMatrixSorted to be valid
     */ 
     int t;        
     /* loop index; the number of the test we're working on*/
     
     int oneTest[NB_ROWS][NB_COLS]; 
     /* the matrix in which we store the test we're working on*/
     
     printf("\nValidating matrixSort function...\n\n"); 
     for(t = 0 ; t < NB_TESTS ; t++){
              extractTest( oneTest, t);       
              
              /* We display the test matrix only if in verbose mode */
              #ifdef VERBOSE_TESTINGS
              printf("Running test #%d\t", t);  
              printf("\n"); 
              displayTest(oneTest);
              printf("\t\t"); 
              #endif
              
              matrixSort(oneTest);
              
              /* In verbose mode, we display the matrix after sorting it */
              #ifdef VERBOSE_TESTINGS
              printf("POST %s \n", isMatrixSorted(oneTest)?"sorted":"not sorted"); 
              displayTest(oneTest);
              
              #else
              
              /* Otherwize, we only display a message if the test failed. */
              if (!isMatrixSorted(oneTest)) 
                 printf("Test #%d \tFAILED\n", t);
              #endif
     }
}

void runAllTests(){
     /* ROLE 
                   Runs all the tests specified and displays results
     */

     runTests1(); 
     runTests2(); 
}

