/* 
Program: module [202] (test.c)

Programmer:  Matthew McDermott          Date: 10/8/2010
Instructor:  Alessio Gaspar	       	   Class:  COP3515.albF10: IT Program Design

Overview: Test Harness scripts - first pass.

*/


#include <stdlib.h> 
#include "setup.h"

/* WARNING - Remember to alter the #defines in setup.h if you modify any of the */
/*           test matrix sizes!!! */



/* The following tests should be replaced by tests which are actually 
 useful to assess the validity of the functions you implement in tools.c
 Make sure you also document the justification for each single tests.*/



/* The following is the tests suite used to validate the isMatrixSorted 
   and matrixSort functions*/
int tests_inputs[NB_TESTS][NB_ROWS][NB_COLS] = {
/*  Test #0 - this is an already sorted matrix to ensure that our function
             does not mess up a sorted matrix by trying to "sort it again" */
    { { 1,  2,  3,  4,  5} , 
      { 6,  7,  8,  9, 10} , 
      {11, 12, 13, 14, 15} }, 
	  
/*  Test #1 - this is a matrix with two elements only being not in order. 
             both are located inside the same row */
    { { 1,  2,  5,  4,  3} , 
      { 6,  7,  8,  9, 10} , 
      {11, 12, 13, 14, 15} },   
	  
/*  Test #3 - this is a matrix with three elements only being not in order. 
             both are located inside the same row and multiple movements required */
    { { 1,  2,  3,  4,  5} , 
      { 6,  8,  9,  7, 10} , 
      {11, 12, 13, 14, 15} },   	 
	  
/*  Test #4 - this is a matrix were the last column in row 1 is greater than
             the first element in row 2.  This tests the logic of moving across various rows. */
    { { 1,  2,  3,  4,  6} , 
      { 5,  7,  8,  9, 10} , 
      {11, 12, 13, 14, 15} },
	  
/*  Test #5 - this is a matrix were the last column in row 2 is greater than
             the first element in row 3.  This tests the logic of moving across
			 various rows while ensuring that the programmer is aware of the coming
			 last row. */
    { { 1,  2,  3,  4,  5} , 
      { 6,  7,  8,  9, 10} , 
      {11, 12, 13, 14, 15} },
	  
/*  Test #6 - this is a matrix were the last column in row 3 is out of sequence.  This tests
			 that the sort function will traverse the entire matrix (array) and sort end to end. */
    { { 2,  3,  4,  5,  6} , 
      { 7,  8,  9, 10, 11} , 
      {12, 13, 14, 15,  1} },    
	  
/*  Test #7 - this is a matrix were the last column in row 1, 2, and 3 is out of sequence.  This tests
			 that the sort function will traverse the entire matrix (array) and sort end to end and does not
			 lose placement between rows where multiple rows must be traversed. End to end sort, one each row 
			 on each column end (and matrix end). */
    { { 2,  3,  4,  5,  7} , 
      { 6,  8,  9, 10, 12} , 
      {11, 13, 14, 15,  1} }, 
	  
/*  Test #8 - This is a sorted array which includes the number 0 to ensure the programmer is comparing values correctly
             in addition, it tests to ensure the sort mechanism identifier does switch to and from unsorted to sorted. */
    { { 0,  1,  2,  3,  4} , 
      { 5,  6,  7,  8,  9} , 
      {10, 11, 12, 13, 14} },
	  
/*  Test #9 - This is an unsorted array with all the same value, except the last value to ensure that the program identifies
             when the values do not require movement ( two or three in a row ). */
    { { 2,  1,  1,  1,  1} , 
      { 1,  1,  1,  1,  1} , 
      { 1,  1,  1,  1,  1} },
	  
/*  Test #10 - This is an unsorted array with all the same sequence of values in each row in order.  This ensures that each value is evaluated
              individually and we are looking across all rows in the matrix to determine sort order. */
    { { 1,  2,  3,  4,  5} , 
      { 1,  2,  3,  4,  5} , 
      { 1,  2,  3,  4,  5} }, 
	  
/*  Test #11 - This is an unsorted array with all the same sequence of values in each row in order.  This ensures that each value is evaluated
              individually and we are looking across all rows in the matrix to determine sort order. */
    { { 5,  4,  3,  2,  1} , 
      { 5,  4,  3,  2,  1} , 
      { 5,  4,  3,  2,  1} },	  
	  
/*  Test #12 - This is a sorted array with gaps, but the values are still in sort order. */
    { {  10,   20,   30,   40,   50}, 
      {  60,   70,   80,   90,  100}, 
      { 110,  120,  130,  140,  150} }, 	  

/*  Test #13 - This is a sorted array with negative integer numbers */
    { {  10,   20,   30,   40,   50}, 
      {  60,   70,   80,   90,  100}, 
      { 110,  120,  130,  0,  -10} } 	 
};

/* For each of the above tests, we record what result we expect from 
 isMatrixSorted. If the result differs from what we expect, an error will be
 displayed */
int tests_expected[NB_TESTS] = { 
    1,                     /* first test is a sorted matrix*/
    0,                     /* second test is not sorted    */
	0,                     /* third test  is not sorted    */
	0,					   /* forth test is not sorted     */
	0,                     /* fifth test is not sorted     */
	0,                     /* sixth test is not sorted     */
	0,                     /* seventh test is not sorted   */
	1,                     /* eighth test is sorted        */
	0, 				       /* ninth test is not sorted     */
	0,                     /* tenth test is not sorted     */
	0,					   /* eleventh test is not sorted  */
	1,					   /* twelth test is sorted        */
	0					   /* thirteenth is not sorted     */
};



