/* 
Program: module [202] (tools.c)

Programmer:  Matthew Mcdermott         Date: 10/8/2010
Instructor:  Alessio Gaspar	       	   Class:  COP3515.albF10: IT Program Design

Overview: Student created isMatrixSorted and MatrixSort which will be tested with professor supplied
	  code templates.

TESTING:  Executed Test file from another peer on 10/10/2010 - No bugs found, only six test cases in the new file.

*/


/*#include <stdio.h>  Debug Only for Printf() */
	
#include <stdlib.h>
#include "setup.h"
     
int isMatrixSorted( int data[NB_ROWS][NB_COLS] ){
    /* ROLE 
                    Determines whether the matrix passed as parameter is sorted
                    with the smallest value in data[0][0], the second smallest 
                    value in data[0][1], and so on and so forth with the largest
                    value in data[NB_ROWS-1][NB_COLS-1]
       RETURNS      0 if the matrix data is not sorted 
                    1 if it is 
       PARAMETERS   data the two dimensional matrix to be sorted
    */
	
	int x,y, tmpvalue;
	
	/* Seed the Start value, rather than play column and row... */
	tmpvalue = data[0][0]; 
    for (x=0; x <= NB_ROWS-1; x++) {
		for (y=0; y <= NB_COLS-1; y++) {
		
			/* printf("\nCoordinates [%d,%d], Value: %d\n", x, y, data[x][y]); DEBUG ONLY! */
		
			if (tmpvalue > data[x][y]) {
				/* printf("\n***> Out of Sort Order!\n"); Debug only */
				return 0;
			}
			
			tmpvalue = data[x][y];
        }
    }	
    return 1;
}

void matrixSort( int data[NB_ROWS][NB_COLS]){
     /* ROLE 
                     sorts the integers in a two dimensional matrix so that the 
                     smallest value is in data[0][0], the second smallest one in 
                     data[0][1], and so on so forth with the largest value in 
                     data[NB_ROWS-1][NB_COLS-1]
        PARAMETERS   data the two dimensional matrix to be sorted
     */ 
     
	 int x, y, z, tmpvalue;
	 
	 
	 /* Bubble sort method. */
	 
	 /* Use the Dimensions of the array to ensure all passes are made to move 
	    data across the entire span of the array 
	 */
	 for (z=0; z <= NB_ROWS*NB_COLS ; z++ ) { 
	    /*  1 Pass through the Array  Each column and row. */
		for (x=0; x <= NB_ROWS-1; x++) {
			for (y=0; y <= NB_COLS-1; y++) {
			    /* Ensure you are not in last row, or in last column, then move data across rows 
				   if the last column in the current row is greater than the first column in the next row
				*/
				if ((x != NB_ROWS-1 ) && (y == NB_COLS-1) && (data[x][y] > data[x+1][y-y])) { 
					tmpvalue = data[x+1][y-y];
					data[x+1][y-y] = data[x][y];
					data[x][y] = tmpvalue;
				/* Simply move data within a row, if the current value is greater than next */
				} else if (data[x][y] > data[x][y+1])	{	
					tmpvalue = data[x][y+1];
					data[x][y+1] = data[x][y];
					data[x][y] = tmpvalue;
				}
				/* printf("\nCoordinates [%d,%d], Value: %d\n", x, y, data[x][y]); - Debug Only */
			}	
		}
	}

	return;
}
